/* Create a WiFi access point and provide a web server on it. */
#include <ESP8266WiFi.h>
#include <WiFiClient.h>
#include <ESP8266WebServer.h>
const char *ssid = "WifiClock";
const char *password = "password";
int channel = 11;

// the IP address for the shield:
IPAddress ip(192, 168, 4, 1);  


String humidityString;
String humidityString1;
String humidityString2;
String pressureString;
String pressureString1;
String pressureString2;
String temperatureCString;
String temperatureCString1;
String temperatureCString2;
String temperatureFString;
String temperatureFString1;
String temperatureFString2;
String request,command,parameters;
String update_days,update_months,update_years,update_hours,update_minutes,update_seconds;
String day1,day2;
String month1,month2;
String year1,year2,year3, year4;
String hourString;
String minuteString;
String secondString;
String hour1;
String minute1;
String second1;
String hour2;
String minute2;
String second2;
String messageText, para1,para2;
float pressure,temperatureC, temperatureF, humidity;

ESP8266WebServer server(80);
//WiFiClient client;  // Default http://192.168.4.1

void handleRoot() {
  server.send(200, "text/html", "<h1>Wifi Clock Ready</h1>");
}
void performGetCommand()
{ 
     // Return the response
     // Test Values
     // Format http://192.168.4.1/GET
      hour1 = 1;
      hour2 = 2;
      minute1 = 3;
      minute2 = 4;
      second1 = 5;
      second2 = 6;
      day1 = 1;
      day2 = 3;
      month1 = 1;
      month2 = 2;
      year3 = 1;
      year4 = 9;
      humidityString1 = "12";
      humidityString2 = "34";
      pressureString1 = "56";
      pressureString2 = "78";
      temperatureCString1 = "12";
      temperatureCString2 = "34";
      temperatureFString1 = "56";
      temperatureFString2 = "78";

      messageText = hour1 + hour2 + "," + minute1+minute2 + "," + 
                    second1+second2 + "," + day1 + day2 + "," + month1 + month2 + ",20" + 
                    year3 + year4 + "," + humidityString1 + "," + humidityString2 + "," +
                    pressureString1 + "," + pressureString2 + "," + temperatureCString1 + "," +
                    temperatureCString2 + "," + temperatureFString1 + "," + temperatureFString2;
      Serial.println(messageText);
      server.send(200, "text/plain",messageText);   
      delay(10);  
}
void performSetCommand()
{
      // FORMAT  http://192.168.4.1/SET?PARA1=HH-MM-SS&PARA2=DD-MM-YY    
      para1 = server.arg("PARA1");       
      para2 = server.arg("PARA2"); 
      update_hours = para1.substring(0,2);
      update_minutes = para1.substring(3,5);
      update_seconds = para1.substring(6,8);
      update_days = para2.substring(0,2);
      update_months = para2.substring(3,5);
      update_years = "20" + para2.substring(6,8); 
      messageText = "Clock Updated";
      server.send(200, "text/plain",messageText);       
      delay(10);
}
void setup() {
  Serial.begin(115200);
  
  WiFi.mode(WIFI_AP);
  WiFi.softAP(ssid, password, 1);
  IPAddress myIP = WiFi.softAPIP();
  server.on("/", handleRoot);
  Serial.println("Start");
  Serial.print("AP IP address: ");
  Serial.println(myIP);
  server.begin();
  Serial.println("HTTP server started");

  server.on("/GET", performGetCommand);
  server.on("/SET", performSetCommand);


}

void loop() {
    server.handleClient();
    delay(1000);
}
